(* GRAPH2.PAS: Please read the bottom of DWIN.PAS for Copyright details. *)

unit Graph2;

interface

uses graph, dos;

procedure initgraph1;
procedure putimage2(y,x: integer; bitmap: pointer; method: word);
procedure test;

implementation

procedure initgraph1;
var
 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;
 regs: registers;

begin
 grDriver := Detect;
 InitGraph(grDriver, grMode,'..');
 ErrCode := GraphResult;
 if ErrCode <> grOk then  Writeln('Graphics error:', GraphErrorMsg(ErrCode));
{ regs.ax := $0012;
 intr($10, regs);}
end;

procedure putimage2(y,x: integer; bitmap: pointer; method: word);
var j, k, l, m, n1,n2, o, shiftstate: word;
 newbit: pointer;
 newofs, newseg, size, newx, newy, newshift: word;
 lshift, rshift: byte;
begin
 j := ofs(bitmap^);
 k := seg(bitmap^);
 getmem(newbit, sizeof(bitmap)*2);
 newofs := ofs(newbit^);
 newseg := seg(newbit^);
 size   := sizeof(newbit^)*2;
 if (x<0) then x := 0;
 if (y<0) then y := 0;
 x := 1 + x;
 y := 1 + y;
 asm
  push ds
  mov  ax, $A000
  mov  es, ax
  mov  ax, ss
  mov  ds, ax
  mov  di, 0
  mov  cx, x
  inc  cx
@@1:
  add  di, $50
  loop @@1
  sub  di, $50
  mov  cx, y
@@12:
  add  di, $1
  sub  cx, $8
  cmp  cx, 0
  jge  @@12
  dec  di
  add  cx, $8
  mov  ax, $8
  inc  cx
@@13:
  dec  ax
  loop @@13
  inc  ax
  mov  dx, ax
  mov  ss:[newshift], ax

  push es
  push di
  mov  ds, ss:[k]
  mov  si, ss:[j]
  mov  es, ss:[newseg]
  mov  di, ss:[newofs]
{shift the image to become one with the correct place}
  lodsw
  inc  ax
  mov  ss:[newx], ax
  stosw
  lodsw

  mov  cx, ax
  mov  ss:[newy], ax
  stosw
  mov  bl, 4
@@shift:
  xor  bh, bh
  mov  dx, ss:[newshift]
  lodsb
  xor  ah, ah
@@shiftlp:
  shl  ax, 1
  dec  dx
  cmp  dx, 0
  je   @@shiftnext
  jmp  @@shiftlp
@@shiftnext:
  xchg ah, al
  stosb
  xchg ah, al
  stosb
  {loop @@shift}
  sub  cx, 8
  jg   @@shift

  mov  cx, ss:[newy]
  dec  bl
  jnz  @@shift

  mov  bl, 4
  dec  ss:[newx]
{  cmp  ss:[newx], 0}
  jnz   @@shift
@@shiftend:
  pop  di
  pop  es
  mov  ds, ss:[newseg]
  mov  si, ss:[newofs]
  lodsw
  lodsw
  inc  ax
  mov  cx, ax

@@bound:
  mov  ax, $FF
  mov  dx, ss:[newy]
  sub  dx, 8
  jg   @@boundnext
  add  dx, 8
  dec  dx
  push cx
  mov  cx, dx
@@boundlp:
  shr  ax, 1
  dec  dx
  cmp  dx, 0
  je   @@boundnext
  jmp  @@boundlp
@@boundnext:
  shl  ax, 1
  loop @@boundnext
  mov  dx, ss:[newshift]
  {add  dx, ss:[newy]}
@@boundlp2:
  shl  ax, 1
  dec  dx
  cmp  dx, 0
  je   @@boundnext2
  jmp  @@boundlp2
@@boundnext2:
  mov  ss:[rshift], al
  mov  ss:[lshift], ah
  pop  cx

  mov  dx, $3CE
  mov  ax, $05
  out  dx, ax

@@3:
  mov  ah, $08
  mov  bx, 2
@@2:
  push bx
  push ax
  xchg bh, bl

  mov  dx, $3CE
  mov  al, 4
  out  dx, ax

  mov  dx, $3C4
  mov  al, $02
  out  dx, ax

  mov  bl, es:[di]
  mov  bl, es:[di]
  mov  bl, es:[di]
  mov  bl, es:[di]
  mov  bl, es:[di]
  mov  bl, es:[di]

  cmp  bh, 2
  je   @@21
  mov  ah, ss:[rshift]
  jmp  @@22
@@21:
  mov  ah, ss:[lshift]
@@22:
  cmp  ss:[method], 0
  je   @@mov
  cmp  ss:[method], 1
  je   @@xor
  cmp  ss:[method], 2
  je   @@or
  cmp  ss:[method], 3
  je   @@and
{  cmp  ss:[method], 4
  je   @@not}
@@mov:
  or   bl, ah
  xor  bl, ah
  lodsb
  or   bl, al
  jmp  @@methdone
@@xor:
  lodsb
  xor   bl, al
  jmp  @@methdone
@@or:
  lodsb
  or   bl, al
  jmp  @@methdone
@@and:
  lodsb
  and   bl, al
  jmp  @@methdone
@@not:
  lodsb
  xor  bl, al
  jmp  @@methdone
@@methdone:
  pop  ax
  mov  bh, es:[di]
  mov  al, bl
  stosb

  pop  bx
  dec  bx
  cmp  bl, 0
  je   @@23
  jmp  @@2
@@23:
  dec  di
  dec  di
  mov  bx, 2
  shr  ah, 1
  cmp  ah, $0
  jz   @@4
  jmp  @@2
@@4:
  add  di, $50

  dec  cx
  cmp  cx, 0
  je   @@41
  jmp  @@3
@@41:

  mov  dx, $3CE
  mov  ax, $05
  out  dx, ax
  mov  dx, $3C4
  mov  ax, $F02
  out  dx, ax


  pop  ds
 end;
 freemem(newbit, sizeof(newbit));
end;

Procedure test;
var skinfile, poinfile: file;
kisp: byte;
kisl: pointer;
upperleft: pointer;
i: integer;
 regs: registers;

begin
{ initgraph1;}
 assign(skinfile, 'Skin.skn');
 filemode := 2;
 reset(skinfile, 1);

 blockread(skinfile, kisp, 1);
 getMem(upperleft, kisp);
 blockread(skinfile, upperleft^, kisp);

 i:=10;
{ bar(0,0,100,100);}
for i := 0  to 20 do begin
{ putimage(i+8,i+8, upperleft^, xorput);}
 putimage2(i,i, upperleft, normalput);
 regs.ax := $1000;
 intr($16, regs);

end;
close(skinfile);
end;
{readln;
 closegraph;}
end.